import { tap, expect } from '@pushrocks/tapbundle';
import { Subject } from 'rxjs';

import * as smartcli from '../ts/index.js';

let smartCliTestObject: smartcli.Smartcli;

tap.test('should create a new Smartcli', async () => {
  smartCliTestObject = new smartcli.Smartcli();
  expect(smartCliTestObject).toBeInstanceOf(smartcli.Smartcli);
});

tap.test('should add an command', async () => {
  expect(smartCliTestObject.addCommand('awesome')).toBeInstanceOf(Subject);
});

tap.test('should start parsing a standardTask', async () => {
  expect(smartCliTestObject.standardCommand()).toBeInstanceOf(Subject);
});

let hasExecuted: boolean = false;

tap.test('should accept a command', async () => {
  smartCliTestObject.addCommand('triggerme').subscribe(() => {
    hasExecuted = true;
  });
});

tap.test('should not have executed yet', async () => {
  expect(hasExecuted).toBeFalse();
});

tap.test('should execute when triggered', async () => {
  smartCliTestObject.triggerCommand('triggerme', {});
  expect(hasExecuted).toBeTrue();
});

tap.test('should start parsing the CLI input', async () => {
  smartCliTestObject.startParse();
  expect(smartCliTestObject.parseCompleted.promise).toBeInstanceOf(Promise);
});

tap.start();
